/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#define MF_SOURCE_NAME  MF_SOURCE_BI_MSG
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>
#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "bi_msg.m4"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static void *
alloc_msgs()
{
	return xcalloc(NMSGS, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + NMSGS; p++) {
		bi_close_message(p);
	}
	free(mtab);
}


#line 36

#line 36
static int MSGTAB_id;
#line 36 "bi_msg.m4"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < NMSGS; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 111


#line 122


#line 133


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 138
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 138
	struct mf_message *mp;
#line 138
			
#line 138
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 138
			env_throw_bi(env, mfe_range, NULL, _("Invalid message descriptor"))
#line 138
;
#line 138
	mp = mtab + nmsg;
#line 138
		if (!(mp->msg))
#line 138
			env_throw_bi(env, mfe_failure, NULL, _("Message not open"))
#line 138

#line 138
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 143
bi_message_close(eval_environ_t env)
#line 143

#line 143 "bi_msg.m4"
{
#line 143
	
#line 143

#line 143

#line 143
long  nmsg;
#line 143
        
#line 143
get_numeric_arg(env, 0, &nmsg);
#line 143
        
#line 143

#line 143
        adjust_stack(env, 1);
#line 143

#line 143
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 143
		prog_trace(env, "message_close %lu",nmsg);;
#line 143

{
	
#line 145
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 145
	struct mf_message *mp;
#line 145
			
#line 145
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 145
			env_throw_bi(env, mfe_range, "message_close", _("Invalid message descriptor"))
#line 145
;
#line 145
	mp = mtab + nmsg;
#line 145
		if (!(mp->msg))
#line 145
			env_throw_bi(env, mfe_failure, "message_close", _("Message not open"))
#line 145

#line 145
;
	bi_close_message(mp);
}
}

/* number message_size(number nmsg) */
void
#line 151
bi_message_size(eval_environ_t env)
#line 151

#line 151 "bi_msg.m4"
{
#line 151
	
#line 151

#line 151

#line 151
long  nmsg;
#line 151
        
#line 151
get_numeric_arg(env, 0, &nmsg);
#line 151
        
#line 151

#line 151
        adjust_stack(env, 1);
#line 151

#line 151
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 151
		prog_trace(env, "message_size %lu",nmsg);;
#line 151

{
	int rc;
	size_t size;
	
#line 155
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 155
	struct mf_message *mp;
#line 155
			
#line 155
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 155
			env_throw_bi(env, mfe_range, "message_size", _("Invalid message descriptor"))
#line 155
;
#line 155
	mp = mtab + nmsg;
#line 155
		if (!(mp->msg))
#line 155
			env_throw_bi(env, mfe_failure, "message_size", _("Message not open"))
#line 155

#line 155
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 158
			env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 160
;
		if (!(size < LONG_MAX))
#line 161
			env_throw_bi(env, mfe_range, "message_size", _("Message size out of representable range"))
#line 163
;
	
#line 164
do {
#line 164
  push(env, (STKVAL) ((long)size));
#line 164
  return;
#line 164
} while (0);
}	
}

/* number message_lines(number nmsg) */
void
#line 169
bi_message_lines(eval_environ_t env)
#line 169

#line 169 "bi_msg.m4"
{
#line 169
	
#line 169

#line 169

#line 169
long  nmsg;
#line 169
        
#line 169
get_numeric_arg(env, 0, &nmsg);
#line 169
        
#line 169

#line 169
        adjust_stack(env, 1);
#line 169

#line 169
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 169
		prog_trace(env, "message_lines %lu",nmsg);;
#line 169

{
	int rc;
	size_t lines;
	
#line 173
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 173
	struct mf_message *mp;
#line 173
			
#line 173
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 173
			env_throw_bi(env, mfe_range, "message_lines", _("Invalid message descriptor"))
#line 173
;
#line 173
	mp = mtab + nmsg;
#line 173
		if (!(mp->msg))
#line 173
			env_throw_bi(env, mfe_failure, "message_lines", _("Message not open"))
#line 173

#line 173
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 176
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 179
;
	
#line 180
do {
#line 180
  push(env, (STKVAL) (lines));
#line 180
  return;
#line 180
} while (0);
}
}

/* number message_body_size(number nmsg) */
void
#line 185
bi_message_body_size(eval_environ_t env)
#line 185

#line 185 "bi_msg.m4"
{
#line 185
	
#line 185

#line 185

#line 185
long  nmsg;
#line 185
        
#line 185
get_numeric_arg(env, 0, &nmsg);
#line 185
        
#line 185

#line 185
        adjust_stack(env, 1);
#line 185

#line 185
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 185
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 185

{
	int rc;
	size_t size;
	
#line 189
	
#line 189
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 189
	struct mf_message *mp;
#line 189
			
#line 189
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 189
			env_throw_bi(env, mfe_range, "message_body_size", _("Invalid message descriptor"))
#line 189
;
#line 189
	mp = mtab + nmsg;
#line 189
		if (!(mp->msg))
#line 189
			env_throw_bi(env, mfe_failure, "message_body_size", _("Message not open"))
#line 189

#line 189
;
#line 189
	if (!mp->body) {
#line 189
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 189
			if (!(rc == 0))
#line 189
			env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 189
;
#line 189
	}	  
#line 189
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 192
			env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 194
;
		if (!(size < LONG_MAX))
#line 195
			env_throw_bi(env, mfe_range, "message_body_size", _("Body size out of representable range"))
#line 197
;
	
#line 198
do {
#line 198
  push(env, (STKVAL) ((long)size));
#line 198
  return;
#line 198
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 203
bi_message_body_lines(eval_environ_t env)
#line 203

#line 203 "bi_msg.m4"
{
#line 203
	
#line 203

#line 203

#line 203
long  nmsg;
#line 203
        
#line 203
get_numeric_arg(env, 0, &nmsg);
#line 203
        
#line 203

#line 203
        adjust_stack(env, 1);
#line 203

#line 203
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 203
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 203

{
	int rc;
	size_t lines;
	
#line 207
	
#line 207
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 207
	struct mf_message *mp;
#line 207
			
#line 207
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 207
			env_throw_bi(env, mfe_range, "message_body_lines", _("Invalid message descriptor"))
#line 207
;
#line 207
	mp = mtab + nmsg;
#line 207
		if (!(mp->msg))
#line 207
			env_throw_bi(env, mfe_failure, "message_body_lines", _("Message not open"))
#line 207

#line 207
;
#line 207
	if (!mp->body) {
#line 207
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 207
			if (!(rc == 0))
#line 207
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 207
;
#line 207
	}	  
#line 207
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 210
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 213
;
	
#line 214
do {
#line 214
  push(env, (STKVAL) (lines));
#line 214
  return;
#line 214
} while (0);
}
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 222
bi_message_header_size(eval_environ_t env)
#line 222

#line 222 "bi_msg.m4"
{
#line 222
	
#line 222

#line 222

#line 222
long  nmsg;
#line 222
        
#line 222
get_numeric_arg(env, 0, &nmsg);
#line 222
        
#line 222

#line 222
        adjust_stack(env, 1);
#line 222

#line 222
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 222
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 222

{
	int rc;
	size_t size;
	
#line 226
	
#line 226
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 226
	struct mf_message *mp;
#line 226
			
#line 226
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 226
			env_throw_bi(env, mfe_range, "message_header_size", _("Invalid message descriptor"))
#line 226
;
#line 226
	mp = mtab + nmsg;
#line 226
		if (!(mp->msg))
#line 226
			env_throw_bi(env, mfe_failure, "message_header_size", _("Message not open"))
#line 226

#line 226
;
#line 226
	if (!mp->hdr) {
#line 226
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 226
			if (!(rc == 0))
#line 226
			env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 226
;
#line 226
	}	  
#line 226
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 229
			env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 231
;
		if (!(size < LONG_MAX))
#line 232
			env_throw_bi(env, mfe_range, "message_header_size", _("Header size out of representable range"))
#line 234
;
	
#line 235
do {
#line 235
  push(env, (STKVAL) ((long)size));
#line 235
  return;
#line 235
} while (0);
}
}

/* number message_header_lines(number nmsg) */
void
#line 240
bi_message_header_lines(eval_environ_t env)
#line 240

#line 240 "bi_msg.m4"
{
#line 240
	
#line 240

#line 240

#line 240
long  nmsg;
#line 240
        
#line 240
get_numeric_arg(env, 0, &nmsg);
#line 240
        
#line 240

#line 240
        adjust_stack(env, 1);
#line 240

#line 240
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 240
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 240

{
	int rc;
	size_t lines;
	
#line 244
	
#line 244
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 244
	struct mf_message *mp;
#line 244
			
#line 244
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 244
			env_throw_bi(env, mfe_range, "message_header_lines", _("Invalid message descriptor"))
#line 244
;
#line 244
	mp = mtab + nmsg;
#line 244
		if (!(mp->msg))
#line 244
			env_throw_bi(env, mfe_failure, "message_header_lines", _("Message not open"))
#line 244

#line 244
;
#line 244
	if (!mp->hdr) {
#line 244
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 244
			if (!(rc == 0))
#line 244
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 244
;
#line 244
	}	  
#line 244
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 247
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 250
;
	
#line 251
do {
#line 251
  push(env, (STKVAL) (lines));
#line 251
  return;
#line 251
} while (0);
}
}

/* number message_header_count(number nmsg) */
void
#line 256
bi_message_header_count(eval_environ_t env)
#line 256

#line 256 "bi_msg.m4"
{
#line 256
	
#line 256

#line 256

#line 256
long  nmsg;
#line 256
        
#line 256
get_numeric_arg(env, 0, &nmsg);
#line 256
        
#line 256

#line 256
        adjust_stack(env, 1);
#line 256

#line 256
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 256
		prog_trace(env, "message_header_count %lu",nmsg);;
#line 256

{
	int rc;
	size_t count;
	
#line 260
	
#line 260
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 260
	struct mf_message *mp;
#line 260
			
#line 260
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 260
			env_throw_bi(env, mfe_range, "message_header_count", _("Invalid message descriptor"))
#line 260
;
#line 260
	mp = mtab + nmsg;
#line 260
		if (!(mp->msg))
#line 260
			env_throw_bi(env, mfe_failure, "message_header_count", _("Message not open"))
#line 260

#line 260
;
#line 260
	if (!mp->hdr) {
#line 260
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 260
			if (!(rc == 0))
#line 260
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 260
;
#line 260
	}	  
#line 260
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 263
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 266
;
	
#line 267
do {
#line 267
  push(env, (STKVAL) (count));
#line 267
  return;
#line 267
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 272
bi_message_has_header(eval_environ_t env)
#line 272

#line 272 "bi_msg.m4"
{
#line 272
	
#line 272

#line 272
long __bi_argcnt;
#line 272
long  nmsg;
#line 272
        char * header;
#line 272
        long  idx;
#line 272
        
#line 272
get_numeric_arg(env, 1, &nmsg);
#line 272
        get_string_arg(env, 2, &header);
#line 272
        get_numeric_arg(env, 3, &idx);
#line 272
        
#line 272
get_numeric_arg(env, 0, &__bi_argcnt);
#line 272
        adjust_stack(env, __bi_argcnt + 1);
#line 272

#line 272
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 272
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 277
	
#line 277
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 277
	struct mf_message *mp;
#line 277
			
#line 277
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 277
			env_throw_bi(env, mfe_range, "message_has_header", _("Invalid message descriptor"))
#line 277
;
#line 277
	mp = mtab + nmsg;
#line 277
		if (!(mp->msg))
#line 277
			env_throw_bi(env, mfe_failure, "message_has_header", _("Message not open"))
#line 277

#line 277
;
#line 277
	if (!mp->hdr) {
#line 277
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 277
			if (!(rc == 0))
#line 277
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 277
;
#line 277
	}	  
#line 277
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 280
do {
#line 280
  push(env, (STKVAL) (rc == 0));
#line 280
  return;
#line 280
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 285
bi_message_find_header(eval_environ_t env)
#line 285

#line 285 "bi_msg.m4"
{
#line 285
	
#line 285

#line 285
long __bi_argcnt;
#line 285
long  nmsg;
#line 285
        char * header;
#line 285
        long  idx;
#line 285
        
#line 285
get_numeric_arg(env, 1, &nmsg);
#line 285
        get_string_arg(env, 2, &header);
#line 285
        get_numeric_arg(env, 3, &idx);
#line 285
        
#line 285
get_numeric_arg(env, 0, &__bi_argcnt);
#line 285
        adjust_stack(env, __bi_argcnt + 1);
#line 285

#line 285
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 285
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 290
	
#line 290
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 290
	struct mf_message *mp;
#line 290
			
#line 290
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 290
			env_throw_bi(env, mfe_range, "message_find_header", _("Invalid message descriptor"))
#line 290
;
#line 290
	mp = mtab + nmsg;
#line 290
		if (!(mp->msg))
#line 290
			env_throw_bi(env, mfe_failure, "message_find_header", _("Message not open"))
#line 290

#line 290
;
#line 290
	if (!mp->hdr) {
#line 290
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 290
			if (!(rc == 0))
#line 290
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 290
;
#line 290
	}	  
#line 290
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("Header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 297
return;
#line 297
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 305
bi_message_is_multipart(eval_environ_t env)
#line 305

#line 305 "bi_msg.m4"
{
#line 305
	
#line 305

#line 305

#line 305
long  nmsg;
#line 305
        
#line 305
get_numeric_arg(env, 0, &nmsg);
#line 305
        
#line 305

#line 305
        adjust_stack(env, 1);
#line 305

#line 305
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 305
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 305

{
	int rc, res;
	
#line 308
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 308
	struct mf_message *mp;
#line 308
			
#line 308
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 308
			env_throw_bi(env, mfe_range, "message_is_multipart", _("Invalid message descriptor"))
#line 308
;
#line 308
	mp = mtab + nmsg;
#line 308
		if (!(mp->msg))
#line 308
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("Message not open"))
#line 308

#line 308
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 311
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 314
;
	
#line 315
do {
#line 315
  push(env, (STKVAL) (res));
#line 315
  return;
#line 315
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 320
bi_message_count_parts(eval_environ_t env)
#line 320

#line 320 "bi_msg.m4"
{
#line 320
	
#line 320

#line 320

#line 320
long  nmsg;
#line 320
        
#line 320
get_numeric_arg(env, 0, &nmsg);
#line 320
        
#line 320

#line 320
        adjust_stack(env, 1);
#line 320

#line 320
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 320
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 320

{
	int rc;
	size_t count;
	
#line 324
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 324
	struct mf_message *mp;
#line 324
			
#line 324
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 324
			env_throw_bi(env, mfe_range, "message_count_parts", _("Invalid message descriptor"))
#line 324
;
#line 324
	mp = mtab + nmsg;
#line 324
		if (!(mp->msg))
#line 324
			env_throw_bi(env, mfe_failure, "message_count_parts", _("Message not open"))
#line 324

#line 324
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 326
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 329
;
	
#line 330
do {
#line 330
  push(env, (STKVAL) (count));
#line 330
  return;
#line 330
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 335
bi_message_get_part(eval_environ_t env)
#line 335

#line 335 "bi_msg.m4"
{
#line 335
	
#line 335

#line 335

#line 335
long  nmsg;
#line 335
        long  idx;
#line 335
        
#line 335
get_numeric_arg(env, 0, &nmsg);
#line 335
        get_numeric_arg(env, 1, &idx);
#line 335
        
#line 335

#line 335
        adjust_stack(env, 2);
#line 335

#line 335
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 335
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 335

{
	int rc;
	mu_message_t msg;
	
#line 339
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 339
	struct mf_message *mp;
#line 339
			
#line 339
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 339
			env_throw_bi(env, mfe_range, "message_get_part", _("Invalid message descriptor"))
#line 339
;
#line 339
	mp = mtab + nmsg;
#line 339
		if (!(mp->msg))
#line 339
			env_throw_bi(env, mfe_failure, "message_get_part", _("Message not open"))
#line 339

#line 339
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 342
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 345
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 347
			env_throw_bi(env, mfe_failure, "message_get_part", _("No more message slots available"))
#line 349
;
	
#line 350
do {
#line 350
  push(env, (STKVAL) (rc));
#line 350
  return;
#line 350
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 358
bi_message_rewind(eval_environ_t env)
#line 358

#line 358 "bi_msg.m4"
{
#line 358
	
#line 358

#line 358

#line 358
long  nmsg;
#line 358
        
#line 358
get_numeric_arg(env, 0, &nmsg);
#line 358
        
#line 358

#line 358
        adjust_stack(env, 1);
#line 358

#line 358
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 358
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 358

{
	int rc;
	mu_stream_t str;
	
#line 362
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 362
	struct mf_message *mp;
#line 362
			
#line 362
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 362
			env_throw_bi(env, mfe_range, "message_rewind", _("Invalid message descriptor"))
#line 362
;
#line 362
	mp = mtab + nmsg;
#line 362
		if (!(mp->msg))
#line 362
			env_throw_bi(env, mfe_failure, "message_rewind", _("Message not open"))
#line 362

#line 362
;
	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 364
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 367
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 369
			env_throw_bi(env, mfe_failure, "message_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 372
;
}
}

/* string message_read_line(number nmsg) */
void
#line 377
bi_message_read_line(eval_environ_t env)
#line 377

#line 377 "bi_msg.m4"
{
#line 377
	
#line 377

#line 377

#line 377
long  nmsg;
#line 377
        
#line 377
get_numeric_arg(env, 0, &nmsg);
#line 377
        
#line 377

#line 377
        adjust_stack(env, 1);
#line 377

#line 377
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 377
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 377

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 382
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 382
	struct mf_message *mp;
#line 382
			
#line 382
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 382
			env_throw_bi(env, mfe_range, "message_read_line", _("Invalid message descriptor"))
#line 382
;
#line 382
	mp = mtab + nmsg;
#line 382
		if (!(mp->msg))
#line 382
			env_throw_bi(env, mfe_failure, "message_read_line", _("Message not open"))
#line 382

#line 382
;

	rc = mu_message_get_stream(mp->msg, &str);
		if (!(rc == 0))
#line 385
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 388
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 390
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 393
;
		if (!(size > 0))
#line 394
			env_throw_bi(env, mfe_not_found, "message_read_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 397
;
	do {pushs(env, mp->buf);
#line 398
return;
#line 398
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 403
bi_message_body_rewind(eval_environ_t env)
#line 403

#line 403 "bi_msg.m4"
{
#line 403
	
#line 403

#line 403

#line 403
long  nmsg;
#line 403
        
#line 403
get_numeric_arg(env, 0, &nmsg);
#line 403
        
#line 403

#line 403
        adjust_stack(env, 1);
#line 403

#line 403
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 403
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 403

{
	int rc;
	mu_stream_t str;
	
#line 407
	
#line 407
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 407
	struct mf_message *mp;
#line 407
			
#line 407
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 407
			env_throw_bi(env, mfe_range, "message_body_rewind", _("Invalid message descriptor"))
#line 407
;
#line 407
	mp = mtab + nmsg;
#line 407
		if (!(mp->msg))
#line 407
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("Message not open"))
#line 407

#line 407
;
#line 407
	if (!mp->body) {
#line 407
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 407
			if (!(rc == 0))
#line 407
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 407
;
#line 407
	}	  
#line 407
;
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 409
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_stream: %s",mu_strerror(rc))
#line 412
;
	rc = mu_stream_seek(str, 0, SEEK_SET);
		if (!(rc == 0))
#line 414
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_stream_seek: %s",mu_strerror(rc))
#line 417
;
}
}

/* string message_read_body_line(number msg)  */
void
#line 422
bi_message_read_body_line(eval_environ_t env)
#line 422

#line 422 "bi_msg.m4"
{
#line 422
	
#line 422

#line 422

#line 422
long  nmsg;
#line 422
        
#line 422
get_numeric_arg(env, 0, &nmsg);
#line 422
        
#line 422

#line 422
        adjust_stack(env, 1);
#line 422

#line 422
	if (prog_trace_option & BUILTIN_MASK_msg)
#line 422
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 422

{
	int rc;
	mu_stream_t str;
	size_t size;
	
#line 427
	
#line 427
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 427
	struct mf_message *mp;
#line 427
			
#line 427
		if (!(nmsg >= 0 && nmsg < NMSGS))
#line 427
			env_throw_bi(env, mfe_range, "message_read_body_line", _("Invalid message descriptor"))
#line 427
;
#line 427
	mp = mtab + nmsg;
#line 427
		if (!(mp->msg))
#line 427
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("Message not open"))
#line 427

#line 427
;
#line 427
	if (!mp->body) {
#line 427
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 427
			if (!(rc == 0))
#line 427
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 427
;
#line 427
	}	  
#line 427
;
	
	rc = mu_body_get_stream(mp->body, &str);
		if (!(rc == 0))
#line 430
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 433
;
	rc = mu_stream_sequential_getline(str, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 435
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_sequential_getline: %s",mu_strerror(rc))
#line 438
;
		if (!(size > 0))
#line 439
			env_throw_bi(env, mfe_not_found, "message_read_body_line", /* FIXME: Should be mfe_eof */
		  "mu_stream_sequential_getline: %s",_("end of input"))
#line 442
;
	do {pushs(env, mp->buf);
#line 443
return;
#line 443
} while (0);
}
}


#line 447
void
#line 447
msg_init_builtin()
#line 447
{
#line 447
	#line 36 "bi_msg.m4"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs);
#line 143 "bi_msg.m4"
va_builtin_install_ex("message_close", bi_message_close, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 151 "bi_msg.m4"
va_builtin_install_ex("message_size", bi_message_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 169 "bi_msg.m4"
va_builtin_install_ex("message_lines", bi_message_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 185 "bi_msg.m4"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 203 "bi_msg.m4"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 222 "bi_msg.m4"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 240 "bi_msg.m4"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 256 "bi_msg.m4"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 272 "bi_msg.m4"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, 0, dtype_number, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 285 "bi_msg.m4"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, 0, dtype_string, 3, 1, 0, dtype_number, dtype_string, dtype_number);
#line 305 "bi_msg.m4"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 320 "bi_msg.m4"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, 0, dtype_number, 1, 0, 0, dtype_number);
#line 335 "bi_msg.m4"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, 0, dtype_number, 2, 0, 0, dtype_number, dtype_number);
#line 358 "bi_msg.m4"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 377 "bi_msg.m4"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);
#line 403 "bi_msg.m4"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, 0, dtype_unspecified, 1, 0, 0, dtype_number);
#line 422 "bi_msg.m4"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, 0, dtype_string, 1, 0, 0, dtype_number);

#line 447 "bi_msg.m4"
		
#line 447
}
#line 580 "../mfd/snarf.m4"

#line 580

